////////////////////////////////////////////////////////////////////////////////
//
//	Author: Leblanc Christophe < christopheleblanc@gmx.com >
//	
//	-This code is distributed for free without any warrantee.
//      -You can use it and redistribute it without restrictions.
//	
////////////////////////////////////////////////////////////////////////////////
function DynamicText(phaser){
	
	var th_ = this;
	
	this.text;
	
	
	this.x = 380;
	this.y = 300;
	
	this.scaleX = 1;
	this.scaleY = 1;
	
	this.alpha = 1;
	
	this.fConfig;
	this.dfConfig;
	
	this.fontSize;
	
	this.charSpaceX = 0;
	this.charSpaceY = 0;
	
	this.originX = 0;
	this.originY = 0;
	
	//Read-only.
	this.computedWidth = 0;
	
	this.children = [];
	
	this.visible = true;
	
	this.debugGraphics;
	this.displayDebug = false;
	
	this.renderTexture = undefined;
	
	this.texPadV = 0;
	this.texPadH = 0;
	
	this.create = function(text, config, dfConfig){
		th_.text = text;
		th_.fConfig = config;
		
		if(dfConfig !== undefined){
			this.dfConfig = dfConfig;
		}
		else{
			this.dfConfig = new DynamicTextConfig.Default();
		}
		
		th_.fontSize = th_.fConfig.fontSize;
		
		th_.addToPhaser();
	}
	
	this.createRenderTexture = function(){
		th_.renderTexture = phaser.add.renderTexture(th_.x, th_.y, th_.computedWidth + th_.texPadH, th_.computedHeight + th_.texPadV);
		return th_.renderTexture;
	}
	
	this.setRenderTexture = function(texture){
		th_.renderTexture = texture;
	}
	
	function getUppercaserDefaultOffsetX(){
		
		if(th_.dfConfig.charUppercaserOffsetSX !== undefined){
			return th_.fontSize * th_.dfConfig.charUppercaserOffsetSX;
		}
		else{
			return th_.dfConfig.charUppercaserOffsetX;
		}
		
	}
	
	function getDefaultOffsetX(){
		
		if(th_.dfConfig.charOffsetSX !== undefined){
			return th_.fontSize * th_.dfConfig.charOffsetSX;
		}
		else{
			return th_.dfConfig.charOffsetX;
		}
		
	}
	
	this.addToPhaser = function(){
		
		var lastSpec = 0;
		var lastOffsetX = 0;
		
		var fX = 0;
		
		var lastDisplayWidth = 0;
		
		var lastI = th_.text.length - 1;
		
		
		
		for(var i = 0; i < th_.text.length; i++){
			
			var charStr = th_.text.charAt(i);
			
			var stepOffsetX = 0;
			
			fX += lastOffsetX;
			
			
			if(th_.dfConfig.charsOffsets.hasOwnProperty(charStr)){
				var offsets = th_.dfConfig.charsOffsets[charStr];
				
				if(offsets.x !== undefined){
					lastOffsetX = offsets.x;
				}
				else if(offsets.sx !== undefined){
					lastOffsetX = th_.fontSize * offsets.sx;
				}
				else{
					lastOffsetX = th_.dfConfig.charOffsetX;//Default
				}
				
			}
			else if(charStr == charStr.toUpperCase()){
				lastOffsetX = getUppercaseDefaultOffsetX();
			}
			else{
				
				lastOffsetX = getDefaultOffsetX();
				
			}
			
			th_.computedWidth += lastOffsetX;
			
			var charX = th_.x + fX;
			
			if(i != 0){
				
				charX += th_.dfConfig.charSpacing;
				
				console.log(charStr + ", " + lastOffsetX.toString() + ", " + charX.toString());
				
				if(i != lastI){
					
					th_.computedWidth += th_.dfConfig.charSpacing;
					
				}
				
			}
			
			var charGobj = phaser.add.text(charX , th_.y, charStr, th_.fConfig);
			if(!th_.visible){
				charGobj.setVisible(false);
			}
			charGobj.setOrigin(0.5, 0.5);
			
			var charObj = new DynamicTextChar();
			charObj.gobj = charGobj;
			charObj.sizeX = lastOffsetX;
			charObj.sizeY = th_.fontSize;
			
			
			th_.children.push(charObj);
		}
		
		th_.computedHalfWidth = th_.computedWidth / 2; // /2
		
		th_.computedHeight = th_.fontSize;
		th_.computedHalfHeight = th_.computedHeight / 2; // /2
		
		th_.debugGraphics = phaser.add.graphics();
		
	}
	
	this.setPosition = function(x, y){
		
		th_.x = x;
		th_.y = y;
		
	}
	
	this.update = function(){
		
		th_.setGroupValues();
		
		if(th_.renderTexture !== undefined){
			th_.renderTexture.x = th_.x;
			th_.renderTexture.y = th_.y;
			th_.renderTexture.setSize(th_.computedWidth + th_.texPadH, th_.fontSize + th_.texPadV);
			th_.renderTexture.clear();
			th_.renderTexture.setOrigin(th_.renderTexture.originX, th_.renderTexture.originY);//Confirm origin will update
			th_.drawToTexture(th_.renderTexture);
		}
		
	}
	
	var debugged = false;
	
	var textOriginXOffset = 0;
	var textOriginYOffset = 0;
	
	this.setGroupValues = function(){
		
		var spacingOffset = 0;
		var lastOffsetX = 0;
		var charOffsetX = 0;
		var charSpaceX = 0;
		
		th_.computedWidth = 0;
		
		var lastI = th_.children.length - 1;
		
		for(var i = 0; i < th_.children.length; i++){
			
			var child = th_.children[i];
			var gobj = child.gobj;
			
			//var originXOffset = gobj.displayWidth * gobj.displayOriginX;
			var gobjOriginXOffset = gobj.displayOriginX;
			
			charOffsetX += lastOffsetX;
			
			if(i != 0){
				
				spacingOffset += th_.dfConfig.charSpacing;
				charOffsetX += spacingOffset;
				
			}
			
			
			
			if(!debugged){
				console.log(child.sizeX + ", " + charOffsetX);
			}
			
			charSpaceX += th_.charSpaceX;
			
			//var charX = th_.x + (charOffsetX * th_.scaleX) + gobjOriginXOffset + charSpaceX - textOriginXOffset + child.offsetX;
			var charX = th_.x + (charOffsetX * th_.scaleX) + gobjOriginXOffset + charSpaceX + child.offsetX;
			
			//var charY = th_.y + (child.sizeY * th_.scaleY) - textOriginYOffset + child.offsetY - (th_.fontSize * 0.5); // add " - (th_.fontSize * 0.5)" when rendering through a texture
			var charY = th_.y + (child.sizeY * th_.scaleY) + child.offsetY - th_.computedHalfHeight; // add " - (th_.fontSize * 0.5)" when rendering through a texture
			
			gobj.x = charX;
			gobj.y = charY;
			
			
			
			
			lastOffsetX = child.sizeX;
		}
		
		th_.computedWidth = charOffsetX + lastOffsetX + charSpaceX;
		th_.computedHalfWidth = th_.computedWidth / 2; // /2
		
		th_.computedHeight = th_.fontSize;
		th_.computedHalfHeight = th_.computedHeight / 2; // /2
		
		textOriginXOffset = th_.computedWidth * th_.originX;
		textOriginYOffset = th_.fontSize * th_.originY;
		
		
		if(th_.debugGraphics !== undefined){
			
			th_.debugGraphics.clear();
			if(th_.displayDebug){
				th_.debugGraphics.fillStyle(0xe5f442, 1);
				th_.debugGraphics.fillCircle(th_.x - textOriginXOffset, th_.y, 2);
				th_.debugGraphics.fillCircle(th_.x + th_.computedHalfWidth - textOriginXOffset, th_.y, 2);
				th_.debugGraphics.fillCircle(th_.x + th_.computedWidth - textOriginXOffset, th_.y, 2);
			}
			
			
		}
		
		if(!debugged){
			debugged = true;
		}
		
	}
	
	this.drawToTexture = function(texture){
		
		//console.og(( (texture.height - th_.fontSize) / 2));
		
		for(var i = 0; i < th_.children.length; i++){
			
			var gobj = th_.children[i].gobj;
			
			texture.draw(gobj, gobj.x - th_.x, gobj.y - th_.y + ( (texture.height - th_.fontSize) / 2));
			
		}
		
	}
	
	this.autoTextWidth = function(){
		
		var x = th_.x;
		var lastDisplayWidth = 0;
		
		var nx = 0;
		
		for(var i = 0; i < th_.children.length; i++){
			var gobj = th_.children[i].gobj;
			nx += lastDisplayWidth;
			gobj.x = x + nx;
			lastDisplayWidth = gobj.displayWidth;
		}
	}
	
	this.setScale = function(scaleX, scaleY){
		
		if(scaleY === undefined){scaleY = scaleX;}
		for(var i = 0; i < th_.children.length; i++){
			th_.children[i].gobj.setScale(scaleX, scaleY);
		}
		
	}
	
	this.destroy = function(){
		for(var i = 0; i < th_.children.length; i++){
			th_.children[i].gobj.destroy();
			th_.children[i].gobj = undefined;
		}
		th_.children = [];
	}
	
}

DynamicTextChar = function(){
	
	this.gobj;
	this.sizeX;//The size of the character
	this.sizeY;//The size of the character
	this.offsetX = 0;
	this.offsetY = 0;
	
}

DynamicTextConfig = {};

DynamicTextConfig.Default = function(){
	
	this.charUppercaserOffsetX = 45;
	this.charOffsetX = 10;
	this.charSpacing = 0;
	
	this.charsOffsets = {};
	
}

DynamicTextConfig.Arial = function(){
	
	this.charUppercaserOffsetX = 45;
	this.charUppercaserOffsetSX = 0.70;
	this.charOffsetX = 36;
	this.charOffsetSX = 0.5625;
	
	this.charSpacing = 0;
	
	this.charsOffsets = {};
	
	this.charsOffsets[" "] = {sx: 0.37};
	this.charsOffsets["D"] = {sx: 0.71};
	this.charsOffsets["T"] = {sx: 0.5625};
	this.charsOffsets["a"] = {sx: 0.625};
	this.charsOffsets["c"] = {sx: 0.37};
	this.charsOffsets["m"] = {sx: 0.9375};
	this.charsOffsets["i"] = {sx: 0.3125};
	this.charsOffsets["x"] = {sx: 0.5625};
	
	/*
	this.charsOffsets[" "] = {x: 24};
	this.charsOffsets["D"] = {x: 46};
	this.charsOffsets["T"] = {x: 36};
	this.charsOffsets["a"] = {x: 40};
	this.charsOffsets["c"] = {x: 24};
	this.charsOffsets["m"] = {x: 60};
	this.charsOffsets["i"] = {x: 20};
	this.charsOffsets["x"] = {x: 36};
	*/
}